/*

Tiedosto   : AttributeInterface.java


Tekij     : Mikko Hiipakka
Luonti pvm : 18.11.2002


Muutokset :

18.11.2002 Mikko Hiipakka
           Luotu


*/


package converge.attribute;

import converge.kernel.XMLContentInterface;
import org.w3c.dom.*;
    /**
    * AttributeInterface:lla mritetn ne ominaisuudet, jotka jokaisen
    * attribuuttien ksittelyn toteuttavien luokkien on tarjottava.
    */

public interface AttributeInterface extends XMLContentInterface{

  /**
   * Ilmentymlle annettava looginen nimi ( jokin supportedAttribute )
  */
  public void setName(String name);

  /**
   * Palauttaa ilmentymlle annettun nimen (attribuutin looginen nimi).
  */
  public String getName();


  /**
   * @return Palauttaa ilmentymn arvosislln
  */
  public Object getValue();

  /**
   * Luokan tietosisllksi annettava arvotieto
   * @param value Annettava tieto Objectina
  */
  public void setValue( Object value );

  /**
   * Luettelo ominaisuuksien nimist, joiden toteutuksen luokka tarjoaa
   * @return Ominaisuuksien nimet String-taulukossa
  */
  public String[] supportedAttributes();

  /**
   * Toteutusluokan tarjoaman palvelun,kytn ja toimminnan selvsanainen kuvaus.
  */
  public String getDescription();

}
