/*

Tiedosto   : ContextModelValueAttribute.java
Luokat     : ContextModelValueAttribute

         
Tekij     : Mikko Hiipakka
Luonti pvm : 19.11.2002


Muutokset :

19.11.2002 Mikko Hiipakka
           Luokan rakenne luotu ja pseudokoodilla suunniteltu toimintaa
15.12.2002 Mikko Hiipakka
           Rakenne tarkistettu
*/

package converge.attribute.attributeImplementations;

import converge.service.Message;
import converge.attribute.*;
import org.w3c.dom.*;
import converge.attribute.MessageAttributeInterface;

/**
 * MessageAttributeInterfacen toteutusluokka, jonka tarkoitus on liitt
 * kontekstimalli vertailun tulos viestiolioon. Tietosislt ksittely kokonaisluvuille 0-100.
*/
public class ContextModelValueAttribute implements MessageAttributeInterface {

  private static String description = "Kontekstimallin vertailun tulos kokonaisluvulla 0-100 prosenttia";
  private int value = 0;
  private String  name;

  public ContextModelValueAttribute(){ }
  
  /**
   * Not implemented ( not needed )
  */
  public boolean compare ( converge.service.Message msg) {
    return true; 
  }

  public boolean compare ( String expressionType, Object value ) {
    int compareValue = ( (Integer)value ).intValue();
   if ( expressionType.equals( "=" ) )
      return ( compareValue == this.value );      
    if ( expressionType.equals( ">" ) )
      return ( compareValue > this.value );      
    if ( expressionType.equals( "<" ) )
      return ( compareValue < this.value );
    if ( expressionType.equals( "<=" ) )
      return ( compareValue <= this.value );
    if ( expressionType.equals( ">=" ) )
      return ( compareValue >= this.value );
    return false;
  }
  
  public Object getValue(){
    return new Integer( this.value );
  }  
  
  public void setValue( Object value ){
    try{
      if ( value instanceof Integer ){
        this.value = ((Integer)value).intValue();
      }
    }catch( Exception e ){
      this.value = 0;
    }
  }
  
  public void setName( String name ){
    this.name = name;
  }
  
  public String getName(){
    return this.name; 
  }
  
  /**
   * Not implemented ( not needed ). Kontekstimallien nimi ei voi etukteen tiet.
  */ 
  public String[] supportedAttributes(){ return null; }

  public String getDescription(){
      return description; 
  }

  /**
   * Not implemented ( not needed )
  */
  public void createXML(org.w3c.dom.Node node) {
    return;
  }
  
  /**
   * Not implemented ( not needed )
  */
  public boolean loadXML(org.w3c.dom.Node node) {
    return true;
  }
  
  /**
   * Not implemented ( not needed )
  */  
  public void setMessage(Message msg){  }
}
