/*
Tiedosto: ClientHandler.java
Luokat:   ClientHandler

Tekij:   Joni Karppinen
Luonti:   25.11.2002

Muutokset:  

4.12.   Joni
       Hahmoteltu / koodattu suurimmaksi osaksi
17.12.  Joni
       Tsmennyst, Javadoccien kirjoitusta        
*/

package converge.clientmanager;
import converge.service.*;


/**

ClientHandler on abstrakti ylluokka kaikentyyppisten asiakasohjelmien ksittelijille.
Luokka tarjoaa aliluokilleen joitakin tiettyj yleisi metodeja, mutta suurin osa
metodeista pit tehd asiakasohjelmakohtaisesti. ClientHandler-luokasta ei tehd koskaan
ilmentymi, ainoastaan sen aliluokista.

*/

public abstract class ClientHandler{

    /**
    Jokaisella ilmentymll ClientHandlerin aliluokista on tunniste, joka
    kertoo minktyyppisen asiakasohjelmarajapinnan se toteuttaa. 
    */
    //public int clientType;

    /**
    Tll on mritelty tunnukset erilaisille asiakasohjelmatyypeille.
    (Tss tapauksessa vain yhdelle, WWW-clientille.)
    */
    //public static final int WWW_CLIENT = 0;

    /** 
    ClientHandlerin kynnistys. 
    Tmn kutsuminen kynnist tarvittavat palvelut ja suorittaa tarvittavat
    alustustoimenpiteet.
    <br><br>
    (Web-clientin tapauksessa kynnistyy webcore,    
    muilla clienteilla jotain muuta, tai ei mitn.)
    */
    public abstract void start(); 

    /**
    ClientHandlerin alasajo.
    */
    public abstract void shutdown();
            
    /**
    * Palauttaa ClientHandler-olion tyypin
    *
    * @return olion tyyppi
    */
    public abstract String getType();
    
    /**
    Viestin lhetys. Voidaan toteuttaa aliluokissa tysin eri tavoilla (mukaanlukien siten, ett mitn ei tehd). 
    @param msg lhetettv viestiolio    
    */
    public abstract void sendMessage(Message msg);
    
}
