/*
Tiedosto: EventManager.java
Luokat:   EventManager, Pair, EventMonitor

Tekij:   Olli Pettay
Luonti:   17.11.2002

Muutokset:
  17.11.2002  Luokan luonti

*/


package converge.kernel;

import java.util.*;
/**
*EventManager huolehtii jrjestelmss syntyneiden ActionEvent-olioiden ksittelyst.
*/
public class EventManager extends Thread{
  private static EventManager em = null;
  
  private EventManager(){}
  
  /**
  *
  */
  public static synchronized EventManager getInstance() { 
    if (em == null) {
      em = new EventManager();
      em.start();
    }
    return em;
  }
  
  public void run() {
    EventMonitor monitor = EventMonitor.getInstance();
    //DEBUG *****************************************************
    Log.output("Event").println("EVENTMANAGER-run : running...");
    //DEBUG *****************************************************
    while(true){
      Pair p = monitor.removeEvent();
      //DEBUG *****************************************************
      Log.output("Event").println("EVENTMANAGER-run : Ksitelln uusi tapahtuma");
      //DEBUG *****************************************************
      ActionEvent ae = p.event;
      Object targetObj = p.object;
      //ActionEventtiin tallennetut eventit
      HashMap events = ae.getEvents();
      //Eventtien loogiset nimet, joilla pyydetn ActionLoaderilta toteutusluokka
      Set keys = events.keySet();
      Iterator it = keys.iterator();
      
      ActionInterface act = null;
      while (it.hasNext()){
        String name = (String)it.next(); 
        act = ActionLoader.newActionInstance( name );
        if(act == null){
          //DEBUG *******************************************************
          Log.output("Event").println("EVENTMANAGER-run : ActionInterface toteutusta ei ollut ladattavissa " + name);
          //DEBUG *******************************************************
          //LOGI
        }else{
          //DEBUG *******************************************************
          Log.output("Event").println("EVENTMANAGER-run : ActionInterface toteutusta ladattu" + name);
          //DEBUG *******************************************************
          Set vSet = (Set)events.get(name);
          String[] values = (String[]) vSet.toArray(new String[vSet.size()]);
          //DEBUG *******************************************************
          Log.output("Event").println("EVENTMANAGER-run : lhetetyt arvot " + values.toString());
          //DEBUG *******************************************************
          try {
          act.setValue( targetObj, values );
          act.doAction(name);
          }
          catch(Exception e) {
            Log.stack(e);
          }
        }
      }
    }
  }
}

//***************************************************************************
//***************************************************************************
//                        CLASS PAIR 
//***************************************************************************
//***************************************************************************
class Pair {
  public Object object = null;
  public ActionEvent event = null;
  public Pair(Object o, ActionEvent evt) {
    this.object = o;
    this.event = evt;
  }
}


//***************************************************************************
//***************************************************************************
//                        CLASS EVENTMONITOR 
//***************************************************************************
//***************************************************************************
class EventMonitor {
  private List eventlist = Collections.synchronizedList(new LinkedList());
  private static EventMonitor em = new EventMonitor();
  
  private EventMonitor(){}
  
  public static EventMonitor getInstance(){
    //DEBUG ****************************************************
    Log.output("Event").println("EVENTMONITOR-getInstance");
    //DEBUG ****************************************************
    return EventMonitor.em;
  }
  
  public synchronized void incomingEvent(Object o, ActionEvent evt) {
    //DEBUG ****************************************************
    Log.output("Event").println("EVENTMONITOR-incomingEvent : Listn listalle --> notifyAll");
    //DEBUG ****************************************************
    eventlist.add(new Pair(o, evt)); 
    this.notifyAll();
  } 
  
  public synchronized Pair removeEvent() {
    //Odotetaan kunnes listalle tulee ksiteltv
    while (this.eventlist.isEmpty())
      try{
        //DEBUG ****************************************************
        Log.output("Event").println("EVENTMONITOR-removeEvent : Toimintolista oli tyhj --> wait");
        //DEBUG ****************************************************  
        wait();
      }catch(Exception e){}
    //DEBUG ****************************************************
    Log.output("Event").println("EVENTMONITOR-removeEvent : Listalla tavaraa palautetaan toimintopyynt");
    //DEBUG ****************************************************  
    //Palautetaan listan ensimminen
    return (Pair)this.eventlist.remove(0);
  }
}
