/*
Tiedosto: RuleHandler.java
Luokat:   RuleHandler

Tekij:   Olli Pettay
Luonti:   17.11.2002

Muutokset:
  17.11.2002  Luokan luonti
  02.12.2002  Olli Pettay
              DroolsHandler->RuleHandler

*/


package converge.kernel;
import converge.service.Message;
import java.util.*;
import org.drools.RuleBase;
import org.drools.rule.*;
import org.drools.WorkingMemory;
import org.drools.TransactionalWorkingMemory;
import org.drools.DroolsException;
import org.drools.AssertionException;
import org.drools.rule.RuleSet;
import org.drools.io.RuleSetLoader;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.*;
/**
* Drools-sntksittelijn liittminen jrjestelmn.
*/
public class RuleHandler{
  private RuleBase ruleBase;
  TransactionalWorkingMemory workingMemory = null;
  
  /**
  *Uuden sntksittelijn luonti
  */
  public RuleHandler() {
    // First, construct an empty RuleBase to be the
    // container for your rule logic.
    this.ruleBase = new RuleBase();
  }

  /**
  *Asetetaan snnt
  *
  *@param rules  snnt
  */
  
  private void setRules(Rule[] rules) {
    try{
    RuleSet ruleSet = new RuleSet("Converge_Rule_Set");
    org.drools.rule.Rule rule;
    Declaration[] dcls;
    for (int i = 0; i < rules.length; ++i) {
      rule = new org.drools.rule.Rule(rules[i].getName());
      dcls = rules[i].getParametersForDrools();
      for (int j = 0; j < dcls.length; ++j)
        rule.addParameterDeclaration(dcls[j]);
      rule.addCondition(rules[i].getConditionForDrools());
      rule.setConsequence(rules[i].getConsequenceForDrools());
      ruleSet.addRule(rule);
    }
    ruleBase.addRuleSet(ruleSet);
    }catch (Exception e) {
      Log.stack(e);
    }
  }
  
  /**
  *Uuden faktan lisys
  *
  *@param o Mik tahansa olio
  */
  private void assertObject(Object o) {
    if (this.workingMemory == null)
      this.workingMemory = this.ruleBase.createTransactionalWorkingMemory();
          try {
       workingMemory.assertObject(o);
      }
      catch (AssertionException e)
      {
        Log.stack(e);
      }
  }
  
  /**
  *Suoritetaan sntksittely
  */
  private void commit() {
    try {
      workingMemory.commit();
    }catch(Exception e) {
      Log.stack(e);
    }
  }
  
  /**
  *Suoritetaan sntksittely oliolle profiilin sntjen mukaisesti
  *
  *@param msg ksiteltv olio
  *@param rules snnt, joita kytetn sntksittelyss
  *@param event ActionEvent-olio, johon kertn tietoa halutuista toimenpiteist
  */
  

 public void processRules(Object ob, Rule[] rules, ActionEvent event) {
    Log.output("RuleHandler").print("RuleHandler - processRules (" + ob + ")...");
    this.setRules(rules);
    this.assertObject(ob);
    this.assertObject(event);
    this.commit();
    Log.output("RuleHandler").println("done.");
 }

}


