/*

Tiedosto   : ActionActivateProfile.java

         
Tekij     : Olli Pettay
Luonti pvm : 13.12.2002


Muutokset :

13.12.2002 Olli Pettay
           Toimintaa hahmoteltu 


*/


package converge.kernel.actionImplementations;

import converge.kernel.ActionInterface;
import converge.kernel.User;
import converge.service.*;
import org.w3c.dom.*;
import java.util.*;

/**
 *Tmn ActionInterface-rajapinnan toteutuksen avulla
 *voidaan profiilien aktiivisuustilaa muuttaa.
 *
*/
public class ActionActivateProfile implements ActionInterface {
  
  
  private final String a = "Activate-Profile";
  private final String b = "DeActivate-Profile";
  private final String c = "Toggle-Profile-Activation";
  private String[] supports = { a, b , c};
  private String description = "Profiilin aktivointi";
  private User user;
  private String[] conf;
  
  
  /**
  *Asetetaan toiminnon arvot.
  *
  *@param givenTarget toiminnon suorittaja
  *@param values parametrit toiminnolle
  */
  public boolean setValue(Object givenTarget, String[] values){
    if (!(givenTarget instanceof User))
      return false;
    this.user = (User)givenTarget;
    this.conf = values;
    return true;
  }
  
  /**
  *Voidaanko toimintoa kytt ajastettujen sntjen yhteydess.
  *
  *@param name toiminnon nimi
  */
  public boolean supportsScheduledRule( String name ){
    if ( name.equals(a))
      return true;
    if ( name.equals(b))
      return true;
    if ( name.equals(c))
      return true;
    return false;
  }


  /**
  *Voidaanko toimintoa kytt tavallisten sntjen yhteydess.
  *
  *@param name toiminnon nimi
  */
  public boolean supportsRule( String name ){
    return false;
  }

  
  /**
   * Suoritetaan toiminto.
   *
   *
   * @param action suoritettavan toiminnon nimi
   * @see setValue
  */ 
  public void doAction( String action ){
    if (action == null)
      return;
      if(this.user.readLock(this)) {
          if ( action.equals(a) ){
              System.out.println("Aktivoidaan profiili");
              for (int i = 0; i < this.conf.length; ++i) {
                  converge.kernel.Profile p = this.user.getProfile(conf[i]);
                  if (p != null)
                      p.setActive(true);
              }
          }
          if ( action.equals(b) ){
              System.out.println("DeAktivoidaan profiili");
              for (int i = 0; i < this.conf.length; ++i) {
                  converge.kernel.Profile p = this.user.getProfile(conf[i]);
                  if (p != null)
                      p.setActive(false);
              }
          }
          if ( action.equals(c) ){
              System.out.println("Vaihdetaan profiilin aktivaatiotilaa");
              for (int i = 0; i < this.conf.length; ++i) {
                  converge.kernel.Profile p = this.user.getProfile(conf[i]);
                  if (p != null) {
                      if (p.isActive())
                          p.setActive(false);
                      else
                          p.setActive(true);
                  }
              }
          }
          this.user.releaseLock(this);
      }
  }
  
  /**
  *Palautetaan tmn luokan toteuttamien toimintojen nimet.
  */
  public String[] supportedActions(){
    return supports;
  }
  
  
  /**
  *Palautetaan luokan selkokielinen kuvaus.
  */
  public String getDescription() {
    return description;
  }
}
