/*

Tiedosto   : ActionGetMessage.java

         
Tekij     : Mikko Hiipakka
Luonti pvm : 07.12.2002


Muutokset :

07.12.2002 Mikko Hiipakka
           Toimintaa hahmoteltu 


*/


package converge.kernel.actionImplementations;

import converge.kernel.ActionInterface;
import converge.kernel.User;
import converge.service.*;
import org.w3c.dom.*;
import java.util.*;

/**
 *Tmn ActionIterface-rajapinnan toteusuksen avulla
 *haetaan viestej tiedonlhteist.
 *
*/
public class ActionGetMessages implements ActionInterface {
  
  
  private final String a = "Get-Message";
  private String[] supports = { a };
  private String description = "Viestin haku";
  private User user;
  private String[] conf;
  
  /**
  *Asetetaan toiminnon arvot.
  *
  *@param givenTarget toiminnon suorittaja
  *@param values parametrit toiminnolle
  */
  
  public boolean setValue(Object givenTarget, String[] values){
    if (!(givenTarget instanceof User))
      return false;
    this.user = (User)givenTarget;
    this.conf = values;
    return true;
  }

  /**
  *Voidaanko toimintoa kytt ajastettujen sntjen yhteydess.
  *
  *@param name toiminnon nimi
  */
  public boolean supportsScheduledRule( String name ){
    if ( name.equals(a))
      return true;
    return false;
  }

  /**
  *Voidaanko toimintoa kytt tavallisten sntjen yhteydess.
  *
  *@param name toiminnon nimi
  */
  public boolean supportsRule( String name ){
    return false;
  }

  
  /**
   * Suoritetaan toiminto.
   *
   *
   * @param action suoritettavan toiminnon nimi
   * @see setValue
  */  
  public void doAction( String action ){
    if (action == null)
      return;
    if(this.user.readLock(this)) {
        if ( action.equals( "Get-Message" ) ){
          //System.out.println("HAETAAN VIESTI");
          for (int i = 0; i < this.conf.length; ++i) {
            DataSource ds = this.user.getDataSource(conf[i]);
            if (ds != null)
              ds.getNewData(this.user);
          }
      
        }
        this.user.releaseLock(this);
    }
  }
  /**
  *Palautetaan tmn luokan toteuttamien toimintojen nimet.
  */
  public String[] supportedActions(){
    return supports;
  }
  
  /**
  *Palautetaan luokan selkokielinen kuvaus.
  */
  public String getDescription() {
    return description;
  }
}
