/*
Tiedosto: PipeMessage.java
Luokat:   PipeMessage

Tekij:   Anssi Johansson
Luonti:   11.12.2002

Muutokset:
  11.12.2002  Luokan luonti

*/

package converge.service;
import java.io.PipedOutputStream;
import java.io.PipedInputStream;

/**
* Tietovarasto liitetiedoston noudossa tulleille virheilmoituksille
*/

public class PipeMessage {

    private PipedInputStream pipe = null;
    private String reply = null;

    /**
    * Oletuskonstruktori.
    *
    * @param pipe tiedostokahva
    * @param reply mahdollinen virheilmoitus
    */
    public PipeMessage(PipedOutputStream pipe, String reply) {
        try {
            this.pipe=new PipedInputStream(pipe);
        } catch(Exception e) {
            this.pipe=null;
        }

        this.reply=reply;
    }

    /**
    * Konstruktori joka tallettaa vain virheilmoituksen.
    *
    * @param reply mahdollinen virheilmoitus
    */
    public PipeMessage(String reply) {
        this.reply=reply;
    }


    /**
    * Kertoo liitetiedostoa noudettaessa tulleen ilmoituksen.
    *
    * @return virheilmoitus, tai null jos ei virhett
    */
    public String getReply() {
        return this.reply;
    }

    /**
    * Palauttaa putken josta liitetiedoston voi lukea.
    *
    * @return putki josta liitetiedoston voi lukea.
    */
    public PipedInputStream getPipe() {
        return this.pipe;
    }
}
