/*
Tiedosto: Message.java
Luokat:

Tekij:   Joni Karppinen
Luonti:   3.12.2002


Muutokset:
  3.12.2002 Joni
              Luokan luonti
  11.12.2002 Olli
              Viestin nyttminen
  15.12.2002 Joni
			  Muutoksia (mm. delete-nappula), selkeyttmist
			  Listty <div>-tageja jotta ulkoasua voidaan sdell CSS-tiedostossa			  
*/

package webcore;
import webcore.webserver.*;
import converge.kernel.*;
import converge.clientmanager.*;
import converge.service.*;
import java.io.*;
import java.util.*;
import org.w3c.dom.*;

/**
Yhden viestin nyttmien sek psy mahdolliseen liitetiedostoon.
<br><br>


*/
public class Message implements WebRequestable{
    static ClientManager cm = ClientManager.getInstance();
    User user;
    long receivedSessionId;
    boolean hasCookie;
    boolean emergencyExit;
	String viewName; 			// ksiteltvn nkymn nimi
	String msgId;				// ksiteltvn viestin id

		
	/**
	Ksitelln HTTP-pyynt.
    <br><br>
    http-parametrit:
    message - message-id
    view - nkymn nimi
	
	@param httpRequest ksiteltv HTTP-pyynt
	*/ 
	public void processRequest(HTTPRequest httpRequest){			
        PrintWriter pw = null;
		
        String tmpCookie = httpRequest.getCookie("session-id");
        if (tmpCookie != null){
            hasCookie = true;
            receivedSessionId = Long.parseLong(tmpCookie);
        }
        user = cm.getUserBySessionId(receivedSessionId);

		// jos ei ole validia user-oliota,
		// loggaudutaan ulos virheilmoituksen kera
		if (user == null)			
			emergencyExit = true;

		if (!emergencyExit){
			// haetaan ensin muuttujiin tarvittavat tiedot...				
			viewName = httpRequest.getFormVar("view");
			msgId = httpRequest.getFormVar("message");
			
		}
			
        try {

          pw = httpRequest.getPrintWriter();		  
		  
		  if (emergencyExit)
			  HtmlUtils.printEmergencyExitPage(pw);

		  else{			  
			  pw.println(htmlHeader);
			  pw.print(HtmlUtils.startPage("Main page"));
			  pw.println("<BODY>");

			  // 'navigaatiopalkki'
			  HtmlUtils.printNavigationBar(pw);
			  
			  pw.print("<p>Logged in as: <b>"+user.getName()+"</b></p>\n");
			  
			  // linkki takaisin nkymn viestilistaan
			  pw.println("<p>Back to <b><a href='webcore.View?view=" 
			  		+ viewName + "'>" + viewName + "</a></b></p>");				
			  	
					
			  // itse viestin tulostus
					
        if (httpRequest.getFormVar("message") != null) {
          String msgId = httpRequest.getFormVar("message");
          converge.service.Message msg = new converge.service.Message(user);
          Document dom = ViewMonitor.getMessage(user, msgId);
          if (dom != null) {
            msg.loadXML(dom);
            String msgSubj = (String)msg.getMessageAttribute("Subject").getValue();
            String msgFrom = (String)msg.getMessageAttribute("From").getValue();
            String msgTo = (String)msg.getMessageAttribute("To").getValue();
            String msgCC = (String)msg.getMessageAttribute("CC").getValue();
            String msgDate = ((Date)msg.getMessageAttribute("Date").getValue()).toString();

			pw.println("<div class='message'>");
			pw.println("<TABLE class='msgheader' width='100%'>");
            if(msgSubj != null)
                pw.println("<tr><td>Subject:</td><td width='100%'>" + HtmlUtils.convertTag2Entity(msgSubj) + "</td></tr>");
            if(msgDate != null)
                pw.println("<tr><td>Date:</td><td>" +HtmlUtils.convertTag2Entity(msgDate) + "</td></tr>");
            if(msgFrom != null)
                pw.println("<tr><td>From:</td><td>" +HtmlUtils.convertTag2Entity(msgFrom) + "</td></tr>");
            if(msgTo != null)
                pw.println("<tr><td>To:</td><td>" +HtmlUtils.convertTag2Entity(msgTo) + "</td></tr>");
            if(msgCC != null)
                pw.println("<tr><td>CC:</td><td>" +HtmlUtils.convertTag2Entity(msgCC) + "</td></tr>");
            converge.service.Attachment[] atts = msg.getAttachmentList();
            if(atts.length>0) {
                if(atts.length>1)
                    pw.println("<tr><td valign='top'>Attachments:</td><td>");
                else
                    pw.println("<tr><td valign='top'>Attachment:</td><td>");

                for(int i = 0; i < atts.length; ++i) {
                    if(i>0)
                       pw.println(",");
                    System.out.println("Message: pointeraddr: " + atts[i].getPointerAddress());
                    converge.service.AttachmentAttributes atr = atts[i].getAttachmentAttributes();
                    String linkExtra="";
                    if(atr.getErrorMessage().length()>0)
                        linkExtra = " style='color: #666666; background: transparent;' title='"+atr.getErrorMessage()+"' ";
                    if(atts[i].getPointerAddress().substring(0,7).equals("http://") ||
                       atts[i].getPointerAddress().substring(0,8).equals("https://"))
                        pw.println("<a "+linkExtra + "href='" + atts[i].getPointerAddress() +"' target='_blank'");
                    else
                        pw.println("<a "+linkExtra + "href='webcore.Attachment?id=" + i +"&message=" + msg.getMessageID() +"'");
                    if(atr.getErrorMessage().length()==0)
                        pw.print(">" + HtmlUtils.convertTag2Entity(atr.getFilename()) + " (" + atr.getSize() + " bytes)</a>");
                    else
                        pw.print(" title='" + atr.getErrorMessage() + "'>" + 
                        HtmlUtils.convertTag2Entity(atr.getFilename()) + " (" + atr.getSize() + " bytes, possibly unavailable)</a>");
                }
                pw.println("</td></tr>");
            }
			pw.println("</TABLE>");
            String msgbody =
				HtmlUtils.convertTag2Entity((String)msg.getMessageAttribute("MESSAGE_BODY").getValue());
            msgbody = msgbody.replaceAll("\n","<br>");
            msgbody = msgbody.replaceAll("\r","");
			// testataan jos sigun saisi ntisti... :)
			msgbody = msgbody.replaceFirst("-- <br>","<div class='sig'>-- <br>");
            pw.print("<br><div class='msgbody'>\n" +msgbody);
			if (msgbody.indexOf("<div class='sig'>") > -1)
				pw.println("</div>");
			pw.println("</div>"); // end msgbody			
			pw.println("</div>"); // end message
			
			// linkki/nappula jolla voi poistaa kyseisen viestin	
			  pw.println("<br>");
			  pw.println("<form method='post' action='webcore.View'>");
              pw.println("<input type=hidden name='delete-message' value='" + msgId +"'>");
              pw.println("<input type=hidden name='view' value='" + viewName + "'>");
              pw.println("<input type=submit name='delete' value='Delete this message'><br>");
              pw.println("</form>");
          }
        }

            //testausta varten:
            HtmlUtils.printTestingStuff(pw, httpRequest);
			
			// sivun loppu:
			HtmlUtils.printEndOfPage(pw);
      }

        }
        catch (Exception e) {
            e.printStackTrace(pw);
        }
        finally {
            try{httpRequest.close();}
                catch (java.io.IOException e2) {e2.printStackTrace(pw);}
        }
	}



}
