/*
Tiedosto: Write.java
Luokat:   Write

Tekij:   Olli Pettay
Luonti:   13.12.2002


Muutokset:
  13.12.2002 Olli
              Luokan luonti
  15.12.2002 Joni
              Pieni muutoksia, kommentointia
  17.12.2002 Joni
              Lhetyksen eponnistuminen kerrotaan nyt mys kyttjlle                                    
*/

package webcore;
import converge.kernel.*;
import converge.clientmanager.*;
import converge.service.*;
import java.io.*;
import java.util.*;
import webcore.webserver.*;

/**
Shkpostiviestien lhetys.

*/
public class Write implements WebRequestable{
  static ClientManager cm = ClientManager.getInstance();
  User user;
  long receivedSessionId;
  boolean hasCookie;
  boolean emergencyExit;
  
    /**
    Ksitelln HTTP-pyynt.
    
    @param httpRequest ksiteltv HTTP-pyynt
    */ 
    public void processRequest(HTTPRequest httpRequest){
        
        PrintWriter pw = null;
        boolean messageSent = false;
        
        // aluksi:  haetaan cookie, sen perusteella user
        String tmpCookie = httpRequest.getCookie("session-id");
        if (tmpCookie != null){
            hasCookie = true;
            receivedSessionId = Long.parseLong(tmpCookie);
        }
        user = cm.getUserBySessionId(receivedSessionId);
    
        if (user == null)
            emergencyExit = true;

        // viestin lhetys (kytten paikallista sendmailia):

        else if(httpRequest.getFormVar("from") != null &&
            (httpRequest.getFormVar("to") != null || httpRequest.getFormVar("to2") != null) &&
            httpRequest.getFormVar("subject") != null &&
            httpRequest.getFormVar("body") != null){                
            String to = httpRequest.getFormVar("to2");
            if (httpRequest.getFormVar("to") != null)
                to = httpRequest.getFormVar("to");
                
            messageSent = converge.service.SMTP.sendMail(
                                    httpRequest.getFormVar("from"),
                                     to,
                                     httpRequest.getFormVar("subject"),
                                     httpRequest.getFormVar("body"),user);

            }

    
        try {
            pw = httpRequest.getPrintWriter();     
          
            if (emergencyExit)
                HtmlUtils.printEmergencyExitPage(pw);
        
          else{
              pw.println(htmlHeader);
              pw.print(HtmlUtils.startPage("Send a new message"));
              pw.println("<BODY>");
              
              // navigaatiopalkki
              HtmlUtils.printNavigationBar(pw);
              
              // Sivun otsikko ja kyttjnimi jolla on kirjauduttu jrjestelmn
              HtmlUtils.printPageInfo(pw, user.getName(), "Write new messages");
                
    
              // ilmoitus onnistuneesta lhetyksest
                
              if (messageSent){
                 pw.println("<div style='text-align:center; margin: 2em;'>");
                 pw.println("<h4>Message sent: "+httpRequest.getFormVar("subject") +
                            "</h4>");
                 pw.println("<form method='post' action='webcore.Write'>"
                            +"<input type=submit value='Ok'>");
                 pw.println("</div>");
              }
              
              // ilmoitus eponnistuneesta lhetyksest
              
              else if (!messageSent && httpRequest.getFormVar("from") != null  && 
                    httpRequest.getFormVar("to") != null){
                 pw.println("<div style='text-align:center; margin: 2em;'>");
                 pw.println("<h4 class='error'>Sending failed</h4>");
                 pw.println("Click 'Back' and try again, or check your email for"
                            +"additional information about this problem.");
                 pw.println("</div>");
                  
              }
                            
              // viestinkirjoituslomake
              else{
                  pw.println("<form method='post' action='webcore.Write'><table>");
                  pw.println("<tr><td>From:</td><td><input size='40' type='text'"      
                        +"name='from' value='testi1@converge.miuku.net'></td><tr>");
                  pw.println("<tr><td>To:</td><td><input size='40' type='text'"
                        +"name='to'></td></tr>");
                  if (user.readLock(this)) {
                      ContactList cl = user.getContactList();
                      Set names = cl.getContactNames();
                      if (!names.isEmpty()) {
                      pw.println("<tr><td>or to:</td><td><select name='to2'>");
                      for (Iterator it = names.iterator(); it.hasNext();) {
                        converge.kernel.Contact c = cl.getContact((String)it.next());
                        pw.println("<option value='" +c.get("email") + "'>" +
                                    c.getName());
                      }
                      pw.println("</select></td></tr>");
                    }
                    user.releaseLock(this);
                  }
                  pw.println("<tr><td>Subject:</td><td><input size='40' type='text'"
                        +"name='subject' value='testi'></td></tr>");
                  pw.println("<tr><td>Body:</td><td><textarea name='body' rows='10'"
                        +"cols='80'>Tm on testiviesti</textarea></td></tr>");
                  pw.println("<tr><td></td><td><input type='submit' name='submit'"
                        +"value='Send message'>");
                  pw.println("<input type='reset' name='reset'></td></tr>");
                  pw.println("</table></form>");
          
                }
            //testausta varten:
            HtmlUtils.printTestingStuff(pw, httpRequest);
            }
        }

        catch (Exception e) {
            e.printStackTrace(pw);
        }

        finally {
            try{httpRequest.close();}
                catch (java.io.IOException e2) {e2.printStackTrace(pw);}
        }
        if (user != null)
            user.releaseLock(this);
    }

}
