

package webcore.webserver;

import java.io.*;

/****
 * Creates and stores the mimeTable as a serialized Hashtable for
 * later reading by MimeType.
 * @see
 * MimeType
 */
public class MimeTypeSetup
{

    static String mimeTable[][] = new String[][]
    {
        {"ai", "application/postscript"},
        {"aif", "audio/aiff"},
        {"aifc", "audio/aiff"},
        {"aiff", "audio/aiff"},
        {"art", "image/x-jg"},
        {"au", "audio/basic"},
        {"avi", "video/avi"},
        {"crt", "application/x-x509-ca-cert"},
        {"css", "text/css"},
        {"der", "application/x-x509-ca-cert"},
        {"dll", "application/x-msdownload"},
        {"doc", "application/msword"},
        {"dot", "application/msword"},
        {"eml", "message/rfc822"},
        {"enc", "video/mpeg"},
        {"eps", "application/postscript"},
        {"exe", "application/x-msdownload"},
        {"fif", "application/fractals"},
        {"gif", "image/gif"},
        {"gz", "application/x-gzip"},
        {"hqx", "application/mac-binhex40"},
        {"htm", "text/html"},
        {"html", "text/html"},
        {"jfif", "image/jpeg"},
        {"jpe", "image/jpeg"},
        {"jpeg", "image/jpeg"},
        {"jpg", "image/jpeg"},
        {"latex", "application/x-latex"},
        {"m1v", "video/mpeg"},
        {"man", "application/x-troff-man"},
        {"mov", "video/quicktime"},
        {"movie", "video/x-sgi-movie"},
        {"mp2", "video/mpeg"},
        {"mpa", "video/mpeg"},
        {"mpe", "video/mpeg"},
        {"mpeg", "video/mpeg"},
        {"mpg", "video/mpeg"},
        {"nws", "message/rfc822"},
        {"ps", "application/postscript"},
        {"qt", "video/quicktime"},
        {"ra", "audio/x-pn-realaudio"},
        {"ram", "audio/x-pn-realaudio"},
        {"rpm", "audio/x-pn-realaudio-plugin"},
        {"rtf", "application/msword"},
        {"sit", "application/x-stuffit"},
        {"snd", "audio/basic"},
        {"swf", "application/x-shockwave-flash"},
        {"tar", "application/x-tar"},
        {"tgz", "application/x-compressed"},
        {"tif", "image/tiff"},
        {"tiff", "image/tiff"},
        {"txt", "text/plain"},
        {"wav", "audio/wav"},
        {"wiz", "application/msword"},
        {"xbm", "image/x-xbitmap"},
        {"z", "application/x-compress"},
        {"zip", "application/x-zip-compressed"}
    };

    /**
     * creates the mime Hashtable and writes it to disk.
     */
    static void createData()
    {
        try
        {
            ObjectOutputStream out =
                new ObjectOutputStream(
                    new FileOutputStream("./classes/webserver/mimetypes.dat"));
            java.util.Hashtable dict = new java.util.Hashtable();
            for (int i=0; i<mimeTable.length; i++)
            {
                System.out.println("Adding: " +
                    mimeTable[i][0] + ", " + mimeTable[i][1]);
                dict.put(mimeTable[i][0], mimeTable[i][1]);
            }
            out.writeObject(dict);
            out.close();
        }
        catch (Exception e)
        {
            System.out.println(e.getMessage());
        }
    }

    static public void main(String args[])
    {
        System.out.println("Starting...");
        createData();
        System.out.println("Done.");

    }
}