package webcore.webserver;

/***
 * Listener interface to receive events from the WebServer
 * @see
 * WebServer
 * WebServerListenerAdapter
 */
public interface WebServerListener extends java.util.EventListener
{
    /***
     * Called when the webserver has started listening in response to the
     * start method.
     */
    public void startedListening(WebServerEvent e);
    /***
     * Called when the webserver has stopped listening in response to the
     * terminate method of an unrecoverable Exception.
     */
    public void stoppedListening(WebServerEvent e);
    /***
     * Called when a minor IO error occurs which is acceptable by the
     * HTTP protocol.  (Especially that clients can close connections without
     * notifying the server.)
     */
    public void minorErrorOccured(WebServerEvent e);

    /***
     * Called when an HTTP request comes in.  The listener may just log the
     * request, or process it completely.  If the request is processed by the
     * listener, the Processed property of the HTTPRequest should be set to
     * true.
     */
    public void requested(WebServerEvent e);

}